Index: trunk/kBuild/tools/ALP.kmk
===================================================================
--- trunk/kBuild/tools/ALP.kmk	(revision 2749)
+++ trunk/kBuild/tools/ALP.kmk	(revision 2750)
@@ -36,5 +36,5 @@
 # Tool Specific Properties
 ifndef PATH_TOOL_ALP
- PATH_TOOL_ALP := $(sort $(wildcard $(KBUILD_DEVTOOLS_BLD)/alp/v*.*))
+ PATH_TOOL_ALP := $(sort $(wildcard $(KBUILD_DEVTOOLS_HST)/alp/v*.*))
  ifneq ($(PATH_TOOL_ALP),)
   PATH_TOOL_ALP := $(call lastword,$(PATH_TOOL_ALP))
Index: trunk/kBuild/tools/JWASM.kmk
===================================================================
--- trunk/kBuild/tools/JWASM.kmk	(revision 2749)
+++ trunk/kBuild/tools/JWASM.kmk	(revision 2750)
@@ -37,5 +37,5 @@
 # Tool Specific Properties
 ifndef TOOL_JWASM_AS
- TOOL_JWASM_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_BLD)/jwasm/*/jwasm$(HOSTSUFF_EXE))))
+ TOOL_JWASM_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_HST)/jwasm/*/jwasm$(HOSTSUFF_EXE))))
  ifeq ($(TOOL_JWASM_AS),)
   TOOL_JWASM_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_TRG)/jwasm/*/jwasm$(HOSTSUFF_EXE))))
Index: trunk/kBuild/tools/MASM510.kmk
===================================================================
--- trunk/kBuild/tools/MASM510.kmk	(revision 2749)
+++ trunk/kBuild/tools/MASM510.kmk	(revision 2750)
@@ -36,5 +36,5 @@
 # Tool Specific Properties
 ifndef TOOL_MASM510_AS
- TOOL_MASM510_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_BLD)/masm/v5.10*/masm$(HOSTSUFF_EXE))))
+ TOOL_MASM510_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_HST)/masm/v5.10*/masm$(HOSTSUFF_EXE))))
  ifeq ($(TOOL_MASM510_AS),)
   TOOL_MASM510_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_TRG)/masm/v5.10*/masm$(HOSTSUFF_EXE))))
Index: trunk/kBuild/tools/MASM600.kmk
===================================================================
--- trunk/kBuild/tools/MASM600.kmk	(revision 2749)
+++ trunk/kBuild/tools/MASM600.kmk	(revision 2750)
@@ -36,5 +36,5 @@
 # Tool Specific Properties
 ifndef TOOL_MASM600_AS
- TOOL_MASM600_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_BLD)/masm/v6.00*/binp/ml$(HOSTSUFF_EXE))))
+ TOOL_MASM600_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_HST)/masm/v6.00*/binp/ml$(HOSTSUFF_EXE))))
  ifeq ($(TOOL_MASM600_AS),)
   TOOL_MASM600_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_TRG)/masm/v6.00*/binp/ml$(HOSTSUFF_EXE))))
Index: trunk/kBuild/tools/MASM610.kmk
===================================================================
--- trunk/kBuild/tools/MASM610.kmk	(revision 2749)
+++ trunk/kBuild/tools/MASM610.kmk	(revision 2750)
@@ -36,5 +36,5 @@
 # Tool Specific Properties
 ifndef TOOL_MASM610_AS
- TOOL_MASM610_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_BLD)/masm/v6.10*/binp/ml$(HOSTSUFF_EXE))))
+ TOOL_MASM610_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_HST)/masm/v6.10*/binp/ml$(HOSTSUFF_EXE))))
  ifeq ($(TOOL_MASM610_AS),)
   TOOL_MASM610_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_TRG)/masm/v6.10*/binp/ml$(HOSTSUFF_EXE))))
Index: trunk/kBuild/tools/MASM6PLUS.kmk
===================================================================
--- trunk/kBuild/tools/MASM6PLUS.kmk	(revision 2749)
+++ trunk/kBuild/tools/MASM6PLUS.kmk	(revision 2750)
@@ -37,9 +37,9 @@
 ifndef TOOL_MASM6PLUS_AS
  TOOL_MASM6PLUS_AS := $(firstword $(rsort $(wildcard \
-	$(KBUILD_DEVTOOLS_BLD)/masm/*/bin$(if $(eq $(KBUILD_HOST),os2),p,)/ml$(HOSTSUFF_EXE)\
+	$(KBUILD_DEVTOOLS_HST)/masm/*/bin$(if $(eq $(KBUILD_HOST),os2),p,)/ml$(HOSTSUFF_EXE)\
 	)))
  ifeq ($(TOOL_MASM6PLUS_AS),)
   TOOL_MASM6PLUS_AS := $(firstword $(rsort $(wildcard \
-	$(KBUILD_DEVTOOLS_BLD)/vcc/*/bin/ml$(HOSTSUFF_EXE) \
+	$(KBUILD_DEVTOOLS_HST)/vcc/*/bin/ml$(HOSTSUFF_EXE) \
 	)))
  endif
Index: trunk/kBuild/tools/MASM710.kmk
===================================================================
--- trunk/kBuild/tools/MASM710.kmk	(revision 2749)
+++ trunk/kBuild/tools/MASM710.kmk	(revision 2750)
@@ -36,5 +36,5 @@
 # Tool Specific Properties
 ifndef TOOL_MASM710_AS
- TOOL_MASM710_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_BLD)/masm/v7.10*/binp/ml$(HOSTSUFF_EXE))))
+ TOOL_MASM710_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_HST)/masm/v7.10*/binp/ml$(HOSTSUFF_EXE))))
  ifeq ($(TOOL_MASM710_AS),)
   TOOL_MASM710_AS := $(firstword $(rsort $(wildcard $(KBUILD_DEVTOOLS_TRG)/masm/v7.10*/binp/ml$(HOSTSUFF_EXE))))
Index: trunk/kBuild/tools/MINGW32.kmk
===================================================================
--- trunk/kBuild/tools/MINGW32.kmk	(revision 2749)
+++ trunk/kBuild/tools/MINGW32.kmk	(revision 2750)
@@ -39,5 +39,5 @@
 # Tool Specific Properties
 ifndef PATH_TOOL_MINGW32
- PATH_TOOL_MINGW32 := $(wildcard $(KBUILD_DEVTOOLS_BLD)/mingw32/v*.*)
+ PATH_TOOL_MINGW32 := $(wildcard $(KBUILD_DEVTOOLS_HST)/mingw32/v*.*)
  ifeq ($(PATH_TOOL_MINGW32),)
   PATH_TOOL_MINGW32 := $(wildcard $(KBUILD_DEVTOOLS)/win.x86/mingw32/v*.*)
Index: trunk/kBuild/tools/MINGWW64.kmk
===================================================================
--- trunk/kBuild/tools/MINGWW64.kmk	(revision 2749)
+++ trunk/kBuild/tools/MINGWW64.kmk	(revision 2750)
@@ -39,5 +39,5 @@
 # Tool Specific Properties
 ifndef PATH_TOOL_MINGWW64
- PATH_TOOL_MINGWW64 := $(wildcard $(KBUILD_DEVTOOLS_BLD)/mingw-w64/r*)
+ PATH_TOOL_MINGWW64 := $(wildcard $(KBUILD_DEVTOOLS_HST)/mingw-w64/r*)
  ifeq ($(PATH_TOOL_MINGWW64),)
   PATH_TOOL_MINGWW64 := $(wildcard $(KBUILD_DEVTOOLS)/win.amd64/mingw-w64/r*)
Index: trunk/kBuild/tools/NASM.kmk
===================================================================
--- trunk/kBuild/tools/NASM.kmk	(revision 2749)
+++ trunk/kBuild/tools/NASM.kmk	(revision 2750)
@@ -36,5 +36,5 @@
 # Tool Specific Properties
 ifndef PATH_TOOL_NASM
- PATH_TOOL_NASM := $(sort $(wildcard $(KBUILD_DEVTOOLS_BLD)/nasm/v*.*))
+ PATH_TOOL_NASM := $(sort $(wildcard $(KBUILD_DEVTOOLS_HST)/nasm/v*.*))
  ifneq ($(PATH_TOOL_NASM),)
   PATH_TOOL_NASM := $(call lastword,$(PATH_TOOL_NASM))
Index: trunk/kBuild/tools/OPENWATCOM.kmk
===================================================================
--- trunk/kBuild/tools/OPENWATCOM.kmk	(revision 2749)
+++ trunk/kBuild/tools/OPENWATCOM.kmk	(revision 2750)
@@ -36,5 +36,5 @@
 ifeq ($(PATH_TOOL_OPENWATCOM),)
  ifeq ($(PATH_TOOL_OPENWATCOM),)
-  PATH_TOOL_OPENWATCOM := $(wildcard $(KBUILD_DEVTOOLS_BLD)/openwatcom/v*)
+  PATH_TOOL_OPENWATCOM := $(wildcard $(KBUILD_DEVTOOLS_HST)/openwatcom/v*)
  endif
  ifeq ($(PATH_TOOL_OPENWATCOM),)
Index: trunk/kBuild/tools/TAR.kmk
===================================================================
--- trunk/kBuild/tools/TAR.kmk	(revision 2749)
+++ trunk/kBuild/tools/TAR.kmk	(revision 2750)
@@ -36,7 +36,7 @@
 # Tool Specific Properties
 ifndef TOOL_TAR_TAR
- TOOL_TAR_TAR := $(wildcard $(KBUILD_DEVTOOLS_BLD)/tar/v*/tar$(HOSTSUFF_EXE))
+ TOOL_TAR_TAR := $(wildcard $(KBUILD_DEVTOOLS_HST)/tar/v*/tar$(HOSTSUFF_EXE))
  ifeq ($(TOOL_TAR_TAR),)
-  TOOL_TAR_TAR := $(wildcard $(KBUILD_DEVTOOLS_BLD)/bin/tar$(HOSTSUFF_EXE))
+  TOOL_TAR_TAR := $(wildcard $(KBUILD_DEVTOOLS_HST)/bin/tar$(HOSTSUFF_EXE))
  endif
  ifneq ($(TOOL_TAR_TAR),)
Index: trunk/kBuild/tools/VAC308.kmk
===================================================================
--- trunk/kBuild/tools/VAC308.kmk	(revision 2749)
+++ trunk/kBuild/tools/VAC308.kmk	(revision 2750)
@@ -36,7 +36,7 @@
 # Determin VAC308 location.
 ifndef PATH_TOOL_VAC308
- PATH_TOOL_VAC308 := $(wildcard $(KBUILD_DEVTOOLS_BLD)/vac/v3.0.8*)
+ PATH_TOOL_VAC308 := $(wildcard $(KBUILD_DEVTOOLS_HST)/vac/v3.0.8*)
  ifeq ($(PATH_TOOL_VAC308),)
-  PATH_TOOL_VAC308 := $(wildcard $(KBUILD_DEVTOOLS_BLD)/vac/v308*)
+  PATH_TOOL_VAC308 := $(wildcard $(KBUILD_DEVTOOLS_HST)/vac/v308*)
  endif
  ifeq ($(PATH_TOOL_VAC308),)
Index: trunk/kBuild/tools/WATCOMC11C.kmk
===================================================================
--- trunk/kBuild/tools/WATCOMC11C.kmk	(revision 2749)
+++ trunk/kBuild/tools/WATCOMC11C.kmk	(revision 2750)
@@ -36,5 +36,5 @@
 ifeq ($(PATH_TOOL_WATCOMC11C),)
  ifeq ($(PATH_TOOL_WATCOMC11C),)
-  PATH_TOOL_WATCOMC11C := $(wildcard $(KBUILD_DEVTOOLS_BLD)/watcom/v11.0c*)
+  PATH_TOOL_WATCOMC11C := $(wildcard $(KBUILD_DEVTOOLS_HST)/watcom/v11.0c*)
  endif
  ifeq ($(PATH_TOOL_WATCOMC11C),)
Index: trunk/kBuild/tools/WGET.kmk
===================================================================
--- trunk/kBuild/tools/WGET.kmk	(revision 2749)
+++ trunk/kBuild/tools/WGET.kmk	(revision 2750)
@@ -36,7 +36,7 @@
 # Tool Specific Properties
 ifndef TOOL_WGET_FETCH
- TOOL_WGET_FETCH := $(wildcard $(KBUILD_DEVTOOLS_BLD)/wget/v*/wget$(HOSTSUFF_EXE))
+ TOOL_WGET_FETCH := $(wildcard $(KBUILD_DEVTOOLS_HST)/wget/v*/wget$(HOSTSUFF_EXE))
  ifneq ($(TOOL_WGET_FETCH),)
-  TOOL_WGET_FETCH := $(wildcard $(KBUILD_DEVTOOLS_BLD)/bin/wget$(HOSTSUFF_EXE))
+  TOOL_WGET_FETCH := $(wildcard $(KBUILD_DEVTOOLS_HST)/bin/wget$(HOSTSUFF_EXE))
  endif
  ifneq ($(TOOL_WGET_FETCH),)
Index: trunk/kBuild/tools/XGCCAMD64LINUX.kmk
===================================================================
--- trunk/kBuild/tools/XGCCAMD64LINUX.kmk	(revision 2749)
+++ trunk/kBuild/tools/XGCCAMD64LINUX.kmk	(revision 2750)
@@ -44,5 +44,5 @@
   TOOL_XGCCAMD64LINUX_PREFIX := x86_64-unknown-linux-gnu-
   ifndef PATH_TOOL_XGCCAMD64LINUX
-   PATH_TOOL_XGCCAMD64LINUX := $(sort $(wildcard $(KBUILD_DEVTOOLS_BLD)/x86_64-unknown-linux-gnu/*))
+   PATH_TOOL_XGCCAMD64LINUX := $(sort $(wildcard $(KBUILD_DEVTOOLS_HST)/x86_64-unknown-linux-gnu/*))
    ifeq ($(PATH_TOOL_XGCCAMD64LINUX),)
     ifeq ($(filter-out win.amd64,$(KBUILD_HOST).$(KBUILD_HOST_ARCH)),) # these can use the windows build.
Index: trunk/kBuild/tools/YASM.kmk
===================================================================
--- trunk/kBuild/tools/YASM.kmk	(revision 2749)
+++ trunk/kBuild/tools/YASM.kmk	(revision 2750)
@@ -36,5 +36,5 @@
 # Tool Specific Properties
 ifndef PATH_TOOL_YASM
- PATH_TOOL_YASM := $(sort $(wildcard $(KBUILD_DEVTOOLS_BLD)/yasm/v*.*))
+ PATH_TOOL_YASM := $(sort $(wildcard $(KBUILD_DEVTOOLS_HST)/yasm/v*.*))
  ifneq ($(PATH_TOOL_YASM),)
   PATH_TOOL_YASM := $(call lastword,$(PATH_TOOL_YASM))
Index: trunk/kBuild/tools/ZIP.kmk
===================================================================
--- trunk/kBuild/tools/ZIP.kmk	(revision 2749)
+++ trunk/kBuild/tools/ZIP.kmk	(revision 2750)
@@ -36,10 +36,10 @@
 # Tool Specific Properties
 ifndef TOOL_ZIP_UNPACK
- TOOL_ZIP_UNPACK := $(wildcard $(KBUILD_DEVTOOLS_BLD)/unzip/v*/unzip$(HOSTSUFF_EXE))
+ TOOL_ZIP_UNPACK := $(wildcard $(KBUILD_DEVTOOLS_HST)/unzip/v*/unzip$(HOSTSUFF_EXE))
  ifeq ($(TOOL_ZIP_UNPACK),)
-  TOOL_ZIP_UNPACK := $(wildcard $(KBUILD_DEVTOOLS_BLD)/zip/v*/unzip$(HOSTSUFF_EXE))
+  TOOL_ZIP_UNPACK := $(wildcard $(KBUILD_DEVTOOLS_HST)/zip/v*/unzip$(HOSTSUFF_EXE))
  endif
  ifeq ($(TOOL_ZIP_UNPACK),)
-  TOOL_ZIP_UNPACK := $(wildcard $(KBUILD_DEVTOOLS_BLD)/bin/unzip$(HOSTSUFF_EXE))
+  TOOL_ZIP_UNPACK := $(wildcard $(KBUILD_DEVTOOLS_HST)/bin/unzip$(HOSTSUFF_EXE))
  endif
  ifneq ($(TOOL_ZIP_UNPACK),)
@@ -52,10 +52,10 @@
 endif
 #ifndef TOOL_ZIP_PACK
-# TOOL_ZIP_PACK := $(wildcard $(KBUILD_DEVTOOLS_BLD)/zip/v*/zip$(HOSTSUFF_EXE))
+# TOOL_ZIP_PACK := $(wildcard $(KBUILD_DEVTOOLS_HST)/zip/v*/zip$(HOSTSUFF_EXE))
 # ifeq ($(TOOL_ZIP_PACK),)
-#  TOOL_ZIP_PACK := $(wildcard $(KBUILD_DEVTOOLS_BLD)/unzip/v*/zip$(HOSTSUFF_EXE))
+#  TOOL_ZIP_PACK := $(wildcard $(KBUILD_DEVTOOLS_HST)/unzip/v*/zip$(HOSTSUFF_EXE))
 # endif
 # ifeq ($(TOOL_ZIP_PACK),)
-#  TOOL_ZIP_PACK := $(wildcard $(KBUILD_DEVTOOLS_BLD)/bin/zip$(HOSTSUFF_EXE))
+#  TOOL_ZIP_PACK := $(wildcard $(KBUILD_DEVTOOLS_HST)/bin/zip$(HOSTSUFF_EXE))
 # endif
 # ifneq ($(TOOL_ZIP_PACK),)